#version 430 core

layout(location = 0) out vec3 Color;
layout(location = 1) out vec3 Glow;

layout(binding = 0) uniform samplerCube cubeMap;

in VS_OUT
{
	vec3 WorldPosition;
	vec3 WorldNormal;
	vec2 UV;
} vertIn;

uniform vec3 cameraPosition;

vec3 getUVT(vec3 N) {
	vec3 coor = vec3(0);
	vec3 Nor = abs(N);
	if(Nor.x > 0.9)
		coor = vec3(N.x, vertIn.UV.x, vertIn.UV.y);
	else if(Nor.y > 0.9)
		coor = vec3(vertIn.UV.x, N.y, vertIn.UV.y);
	else
		coor = vec3(vertIn.UV.x, vertIn.UV.y, N.z);
	
	return coor;
}

void main(void) {
	vec3 view = normalize(vertIn.WorldPosition - cameraPosition);
	vec3 uvt = reflect(view, normalize(vertIn.WorldNormal));
	//vec3 n = round(normalize(vertIn.WorldNormal));
	//vec3 uvt = getUVT(n);
	Color = texture(cubeMap, uvt).rgb;
	//Color = vec3(1);
	Glow = vec3(0);
}
