#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec3 tangent;
layout(location = 3) in vec2 uv;

out VS_OUT
{
	vec3 WorldPosition;
	vec3 WorldNormal;
	vec2 UV;
} vertOut;


uniform mat4 viewProjectionMatrix;
uniform mat4 modelMatrix;

void main(void) {
	vertOut.WorldPosition = vec3(modelMatrix * vec4(position, 1));
	vertOut.WorldNormal = transpose(inverse(mat3(modelMatrix))) * normal;
	vertOut.UV = uv;
	
	gl_Position = viewProjectionMatrix * modelMatrix * vec4(position, 1);
}