#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec2 verTexcoord;
out vec3 verNormal;
out vec3 verPosition;

uniform mat4 viewProjMatrix;
uniform mat4 modelMatrix;

void main(void) {
	
	verTexcoord = uv;
	verNormal = mat3(modelMatrix) * normal;
	verPosition = vec3(modelMatrix * vec4(position, 1));
	gl_Position = viewProjMatrix * vec4(verPosition, 1);
	
}

/*
uniform mat4 mvp;

void main(void) {

	const vec4 vertices[6] = vec4[6](vec4(-1.f, -1.f, 0, 1), 
									 vec4(1.f, -1.f, 0, 1), 
									 vec4(1.f, 1.f, 0, 1),
									 vec4(1.f, 1.f, 0, 1),
									 vec4(-1.f, 1.f, 0, 1),
									 vec4(-1.f, -1.f, 0, 1));
	
	gl_Position = mvp * (vertices[gl_VertexID] * vec4(0.5f,0.5f,0,1));
}
*/